Index: palm/trunk/SOURCE/advec_s_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_pw.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_s_pw.f90	(revision 1)
@@ -1,40 +1,48 @@
-!> @file advec_s_pw.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_s_pw_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: advec_s_pw.f90,v $
+! Revision 1.12  2006/02/23 09:42:55  raasch
+! nzb_2d replaced by nzb_s_inner
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.11  2004/01/30 10:10:03  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
 !
-! 3927 2019-04-23 13:24:29Z raasch
-! pointer attribute removed from scalar 3d-array for performance reasons
+! Revision 1.10  2003/03/12 16:15:32  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
 !
-! 3665 2019-01-10 08:28:24Z raasch
-! unused variables removed
+! Revision 1.9  2002/06/11 12:22:14  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+! Array sk now declared as a pointer.
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! nopointer option removed
+! Revision 1.8  2001/03/29 17:30:14  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.7  2001/01/22 04:41:39  raasch
+! Module test_variables removed
+!
+! Revision 1.6  2000/01/20 09:13:33  letzel
+! All comments translated into English
+!
+! Revision 1.5  1998/07/06 12:03:09  raasch
+! + USE test_variables
+!
+! Revision 1.4  1998/04/21 15:51:53  raasch
+! Galilei-Transformation eingebaut
+!
+! Revision 1.3  1998/02/10 14:57:53  raasch
+! Es wird jetzt grundsaetzlich die Form C3 verwendet
+!
+! Revision 1.2  1997/09/09 08:27:10  raasch
+! Kehrwerte der Gitterweiten implementiert
 !
 ! Revision 1.1  1997/08/29 08:54:20  raasch
@@ -44,12 +52,11 @@
 ! Description:
 ! ------------
-!> Advection term for scalar variables using the Piacsek and Williams scheme (form C3). Contrary to
-!> PW itself, for reasons of accuracy their scheme is slightly modified as follows: the values of
-!> those scalars that are used for the computation of the flux divergence are reduced by the value
-!> of the relevant scalar at the location where the difference is computed (sk(k,j,i)).
-!> NOTE: at the first grid point above the surface computation still takes place!
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_s_pw_mod
-
+! Advection term for scalar variables using the Piacsek and Williams scheme
+! (form C3). Contrary to PW itself, for reasons of accuracy their scheme is
+! slightly modified as follows: the values of those scalars that are used for
+! the computation of the flux divergence are reduced by the value of the
+! relevant scalar at the location where the difference is computed (sk(k,j,i)).
+! NOTE: at the first grid point above the surface computation still takes place!
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -60,136 +67,76 @@
        MODULE PROCEDURE advec_s_pw_ij
     END INTERFACE
-
+ 
  CONTAINS
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_s_pw( sk )
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_s_pw( sk )
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  dd2zu, tend, u, u_stokes_zu, v, v_stokes_zu, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
+       INTEGER ::  i, j, k
 
-    USE indices,                                                                                   &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+       REAL, DIMENSION(:,:,:), POINTER ::  sk
+ 
 
-    USE kinds
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt-1
+                tend(k,j,i) = tend(k,j,i)                                      &
+              -0.5 * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+                     - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
+                     ) * ddx                                                   &
+              -0.5 * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
+                     - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
+                     ) * ddy                                                   &
+              -      (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
+                     -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
+                     ) * dd2zu(k)
+             ENDDO
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE advec_s_pw
 
 
-    IMPLICIT NONE
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_s_pw_ij( i, j, sk )
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    REAL(wp)     ::  gu  !< local additional advective velocity
-    REAL(wp)     ::  gv  !< local additional advective velocity
+       IMPLICIT NONE
 
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
+       INTEGER ::  i, j, k
+
+       REAL, DIMENSION(:,:,:), POINTER ::  sk
 
 
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
+       DO  k = nzb_s_inner(j,i)+1, nzt-1
+          tend(k,j,i) = tend(k,j,i)                                            &
+              -0.5 * ( ( u(k,j,i+1) - u_gtrans ) * ( sk(k,j,i+1) - sk(k,j,i) ) &
+                     - ( u(k,j,i)   - u_gtrans ) * ( sk(k,j,i-1) - sk(k,j,i) ) &
+                     ) * ddx                                                   &
+              -0.5 * ( ( v(k,j+1,i) - v_gtrans ) * ( sk(k,j+1,i) - sk(k,j,i) ) &
+                     - ( v(k,j,i)   - v_gtrans ) * ( sk(k,j-1,i) - sk(k,j,i) ) &
+                     ) * ddy                                                   &
+              -      (   w(k,j,i)                * ( sk(k+1,j,i) - sk(k,j,i) ) &
+                     -   w(k-1,j,i)              * ( sk(k-1,j,i) - sk(k,j,i) ) &
+                     ) * dd2zu(k)
+       ENDDO
 
-!
-!--          Galilean transformation + Stokes drift velocity (ocean only)
-             gu = u_gtrans - u_stokes_zu(k)
-             gv = v_gtrans - v_stokes_zu(k)
-
-             tend(k,j,i) = tend(k,j,i) +                                                           &
-                                  ( -0.5_wp * ( ( u(k,j,i+1)  - gu        ) *                      &
-                                                ( sk(k,j,i+1) - sk(k,j,i) )                        &
-                                              - ( u(k,j,i)    - gu        ) *                      &
-                                                ( sk(k,j,i-1) - sk(k,j,i) )                        &
-                                              ) * ddx                                              &
-                                    -0.5_wp * ( ( v(k,j+1,i)  - gv        ) *                      &
-                                                ( sk(k,j+1,i) - sk(k,j,i) )                        &
-                                              - ( v(k,j,i)    - gv        ) *                      &
-                                                ( sk(k,j-1,i) - sk(k,j,i) )                        &
-                                              ) * ddy                                              &
-                                    -         (   w(k,j,i)                  *                      &
-                                                ( sk(k+1,j,i) - sk(k,j,i) )                        &
-                                              -   w(k-1,j,i)                *                      &
-                                                ( sk(k-1,j,i) - sk(k,j,i) )                        &
-                                              ) * dd2zu(k)                                         &
-                                   )
-          ENDDO
-       ENDDO
-    ENDDO
-
- END SUBROUTINE advec_s_pw
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_s_pw_ij( i, j, sk )
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  dd2zu, tend, u, u_stokes_zu, v, v_stokes_zu, w
-
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-
-    REAL(wp)     ::  gu  !< local additional advective velocity
-    REAL(wp)     ::  gv  !< local additional advective velocity
-
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
-
-
-    DO  k = nzb+1, nzt
-
-!
-!--    Galilean transformation + Stokes drift velocity (ocean only)
-       gu = u_gtrans - u_stokes_zu(k)
-       gv = v_gtrans - v_stokes_zu(k)
-
-       tend(k,j,i) = tend(k,j,i) +                                                                 &
-                                 ( -0.5_wp * ( ( u(k,j,i+1)  - gu        ) *                       &
-                                               ( sk(k,j,i+1) - sk(k,j,i) )                         &
-                                             - ( u(k,j,i)    - gu        ) *                       &
-                                               ( sk(k,j,i-1) - sk(k,j,i) )                         &
-                                             ) * ddx                                               &
-                                   -0.5_wp * ( ( v(k,j+1,i)  - gv        ) *                       &
-                                               ( sk(k,j+1,i) - sk(k,j,i) )                         &
-                                             - ( v(k,j,i)    - gv        ) *                       &
-                                               ( sk(k,j-1,i) - sk(k,j,i) )                         &
-                                             ) * ddy                                               &
-                                   -         (   w(k,j,i)                  *                       &
-                                               ( sk(k+1,j,i) - sk(k,j,i) )                         &
-                                             -   w(k-1,j,i)                *                       &
-                                               ( sk(k-1,j,i) - sk(k,j,i) )                         &
-                                             ) * dd2zu(k)                                          &
-                                 )
-    ENDDO
-
- END SUBROUTINE advec_s_pw_ij
+    END SUBROUTINE advec_s_pw_ij
 
  END MODULE advec_s_pw_mod
Index: palm/trunk/SOURCE/advec_s_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_up.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_s_up.f90	(revision 1)
@@ -1,40 +1,45 @@
-!> @file advec_s_up.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_s_up_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
-! Former revisions:
+!
+! Forner revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: advec_s_up.f90,v $
+! Revision 1.11  2006/02/23 09:43:44  raasch
+! nzb_2d replaced by nzb_s_inner
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.10  2004/01/30 10:10:39  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
 !
-! 3927 2019-04-23 13:24:29Z raasch
-! pointer attribute removed from scalar 3d-array for performance reasons
+! Revision 1.9  2003/03/12 16:16:25  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
 !
-! 3665 2019-01-10 08:28:24Z raasch
-! unused variables removed
+! Revision 1.8  2002/06/11 12:23:31  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+! Array sk now declared as a pointer.
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! nopointer option removed
+! Revision 1.7  2001/03/29 17:30:31  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.6  2001/01/22 04:43:56  raasch
+! Module test_variables removed
+!
+! Revision 1.5  2000/01/20 09:16:59  letzel
+! All comments translated into English
+!
+! Revision 1.4  1998/07/06 12:03:46  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/04/21 15:52:14  raasch
+! Galilei-Transformation eingebaut
+!
+! Revision 1.2  1997/09/09 08:27:24  raasch
+! Kehrwerte der Gitterweiten implementiert
 !
 ! Revision 1.1  1997/08/29 08:54:33  raasch
@@ -44,10 +49,8 @@
 ! Description:
 ! ------------
-!> Advection term for scalar quantities using the Upstream scheme.
-!> NOTE: vertical advection at k=1 still has wrong grid spacing for w>0!
-!>       The same problem occurs for all topography boundaries!
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_s_up_mod
-
+! Advection term for scalar quantities using the Upstream scheme.
+! NOTE: vertical advection at k=1 still has wrong grid spacing for w>0!
+!       The same problem occurs for all topography boundaries!
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -62,138 +65,116 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_s_up( sk )
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_s_up( sk )
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
+       INTEGER ::  i, j, k
 
-    USE indices,                                                                                   &
-        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
-
-    USE kinds
+       REAL ::  ukomp, vkomp, wkomp
+       REAL, DIMENSION(:,:,:), POINTER ::  sk
 
 
-    IMPLICIT NONE
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+!
+!--             x-direction
+                ukomp = 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
+                IF ( ukomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
+                ENDIF
+!
+!--             y-direction
+                vkomp = 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
+                IF ( vkomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
+                ENDIF
+!
+!--             z-direction
+                wkomp = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
+                IF ( wkomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1)
+                ENDIF
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
+             ENDDO
+          ENDDO
+       ENDDO
 
-    REAL(wp) ::  ukomp !< advection velocity along x-direction
-    REAL(wp) ::  vkomp !< advection velocity along y-direction
-    REAL(wp) ::  wkomp !< advection velocity along z-direction
-
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< treated scalar
+    END SUBROUTINE advec_s_up
 
 
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-!
-!--          x-direction
-             ukomp = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
-             IF ( ukomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
-             ENDIF
-!
-!--          y-direction
-             vkomp = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
-             IF ( vkomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
-             ENDIF
-!
-!--          z-direction
-             wkomp = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
-             IF ( wkomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - wkomp * ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - wkomp * ( sk(k+1,j,i) - sk(k,j,i) ) * ddzu(k+1)
-             ENDIF
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_s_up_ij( i, j, sk )
 
-          ENDDO
-       ENDDO
-    ENDDO
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
- END SUBROUTINE advec_s_up
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+
+       REAL ::  ukomp, vkomp, wkomp
+       REAL, DIMENSION(:,:,:), POINTER ::  sk
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_s_up_ij( i, j, sk )
+       DO  k = nzb_s_inner(j,i)+1, nzt
+!
+!--       x-direction
+          ukomp = 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
+          IF ( ukomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
+          ENDIF
+!
+!--       y-direction
+          vkomp = 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
+          IF ( vkomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
+          ENDIF
+!
+!--       z-direction
+          wkomp = 0.5 * ( w(k,j,i) + w(k-1,j,i) )
+          IF ( wkomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( sk(k+1,j,i)-sk(k,j,i) ) * ddzu(k+1)
+          ENDIF
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
+       ENDDO
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-
-    REAL(wp) ::  ukomp !< advection velocity along x-direction
-    REAL(wp) ::  vkomp !< advection velocity along y-direction
-    REAL(wp) ::  wkomp !< advection velocity along z-direction
-
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< treated scalar
-
-
-    DO  k = nzb+1, nzt
-!
-!--    x-direction
-       ukomp = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
-       IF ( ukomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( sk(k,j,i) - sk(k,j,i-1) ) * ddx
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( sk(k,j,i+1) - sk(k,j,i) ) * ddx
-       ENDIF
-!
-!--    y-direction
-       vkomp = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
-       IF ( vkomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( sk(k,j,i) - sk(k,j-1,i) ) * ddy
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( sk(k,j+1,i) - sk(k,j,i) ) * ddy
-       ENDIF
-!
-!--    z-direction
-       wkomp = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
-       IF ( wkomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - wkomp * ( sk(k,j,i) - sk(k-1,j,i) ) * ddzu(k)
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - wkomp * ( sk(k+1,j,i) - sk(k,j,i) ) * ddzu(k+1)
-       ENDIF
-
-    ENDDO
-
- END SUBROUTINE advec_s_up_ij
+    END SUBROUTINE advec_s_up_ij
 
  END MODULE advec_s_up_mod
